平台：ubuntu18.04

环境安装根据 [rcore 文档](https://rcore-os.github.io/rCore-Tutorial-Book-v3/chapter0/5setup-devel-env.html) 安装即可，这里增加 gdb 插件调试的内容。

# 安装 `riscv64-unknown-elf-gdb`

rcore 文档中使用的 `riscv64-unknown-elf-gdb` 不支持 python，因此 gdb 的插件无法使用，即使使用 `riscv64-unknown-elf-gdb-py` 也一样。

有的使用 `gdb-multiarch`，不过 ubuntu18.04 的该版本好像不支持 riscv 架构。

我们需要下载 gdb 源码，重新编译

1. 前往[清华镜像](https://mirrors.tuna.tsinghua.edu.cn/gnu/gdb/?C=M&O=D)下载最新的 GDB 源代码（测试过 gdb-12.1 版本是可以使用的）

2. 进入目录，执行以下命令

   - `--prefix` 是安装的路径，按照以上指令会安装到 `/usr/local/bin/` 下（为了防止可能覆盖原来的文件，可以新建一个文件夹存放，然后更改 `~/.bashrc` 相关的参数）
   - `--with-python` 是 `python` 的地址，它和 `--enable-tui` 都是为了支持后续安装一个可视化插件（好像该地址最好默认，使用 anaconda 的 python 好像编译不成功）

   ```bash
   mkdir build
   cd build
   ../configure --prefix=/usr/local --with-python=/usr/bin/python --target=riscv64-unknown-elf --enable-tui=yes
   ```

3. 编译安装（只编译出 `riscv64-unknown-elf-gdb`）

   ```bash
   # Linux
   make -j$(nproc)
   
   sudo make install
   ```

   如果编译失败，出现该错误 `configure: error: no enhanced curses library found; disable TUI`，只需执行 `sudo apt-get install libncurses5-dev` 安装缺失的库，然后重新编译即可。

4. 安装 [`gdb-dashboard`](https://github.com/cyrus-and/gdb-dashboard/) 插件

   ```bash
   wget -P ~ https://git.io/.gdbinit
   ```

# 参考资料

[GDB 调试方法* · GitBook (rcore-os.cn)](http://rcore-os.cn/rCore-Tutorial-deploy/docs/pre-lab/gdb.html)