#![no_std]
#[macro_use]
extern crate alloc;

#[macro_use]
extern crate bitflags;

mod block_cache;
mod block_dev;
mod dir_entry;
mod fat32_manager;
mod layout;
mod vfs;
#[macro_use]
mod console;
mod sbi;

pub const BLOCK_SZ: usize = 512;
use block_cache::{get_block_cache, set_start_sec, block_cache_sync_all};
pub use block_dev::BlockDevice;
pub use fat32_manager::FAT32Manager;
pub use dir_entry::*;
pub use layout::*;
pub use vfs::Inode;
